<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use think\Db;
/**
 * 用户提现申请
 *
 * @icon fa fa-circle-o
 */
class Usertakecash extends Backend
{

    /**
     * Usertakecash模型对象
     * @var \app\admin\model\Usertakecash
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\Usertakecash;
        $this->view->assign("typeList", $this->model->getTypeList());
        $this->view->assign("statusList", $this->model->getStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('user')->visible(['nickname','mobile','avatar']);
            }

            /*$result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);*/

            $list2 = collection($list->items())->toArray();
            foreach($list2 as $key => &$info){
                $account_info = json_decode($info['acount_json'],true);
                if($info['type'] == 2){ //银行
                    $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['bank_no'].'，开户行:'.$account_info['open_bank'];
                }elseif($info['type'] == 1){ //支付宝
                    $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['pay_no'];
                }else{ //微信
                    $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['pay_no'];
                }
            }

            $result = array("total" => $list->total(), "rows" => $list2);

            return json($result);
        }
        return $this->view->fetch();
    }

    /**
     * 审核
     */
    public function audit(){
        $id = input('id');
        $info = Db::name('user_take_cash')
            ->where('id',$id)
            ->find();

        if ($this->request->isPost()) {
            $status = input('status',0);
            $data = [
                'status' => $status,
                'auditremark' => input('auditremark',''),
                'audittime' => strtotime(input('audittime','')),
                'updatetime' => time(),
            ];
            Db::startTrans();
            $rs = Db::name('user_take_cash')->where('id',$id)->update($data);

            if($status == 1){
                $remark = '提现(成功)';
                Db::name('user_money_log')->where('table','user_take_cash')->where('table_id',$id)->update(['remark'=>$remark]);
            }elseif($status == 2){
                $remark = '提现(驳回)';
                Db::name('user_money_log')->where('table','user_take_cash')->where('table_id',$id)->update(['remark'=>$remark]);

                //还钱
                $wallet_rs = model('wallet')->lockChangeAccountRemain($info['user_id'],'money',$info['money'],22,'提现被拒返回:'.$info['money'],'user_take_cash',$id);
                if($wallet_rs['status'] === false){
                    Db::rollback();
                    $this->error($wallet_rs['msg']);
                }
            }
            Db::commit();

            $this->success('审核完成');
        }

        $account_info = json_decode($info['acount_json'],true);
        if($info['type'] == 2){
            $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['bank_no'].'，开户行:'.$account_info['open_bank'];
        }elseif($info['type'] == 1){
            $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['pay_no'];
        }else{
            $info['account_info'] = '姓名:'.$account_info['realname'].'，账号:'.$account_info['pay_no'];
        }
        $this->assign('row',$info);
        return $this->view->fetch();
    }

}
